//Example from here: http://academy.cba.mit.edu/2013/students/rees.john/output-devices/

#define  cT     3830    // 261 Hz
#define  dT     3400    // 294 Hz
#define  eT     3038    // 329 Hz
#define  fT     2864    // 349 Hz
#define  gT     2550    // 392 Hz
#define  aT     2272    // 440 Hz
#define  bT     2028    // 493 Hz
#define  CT     1912    // 523 Hz
// Define a special note, 'R', to represent a rest
#define  RT     0

// Use a PWM pin  
int speakerOut = PA7;

void setup() {
  pinMode(speakerOut, OUTPUT);
  
}

// Set overall tempo
long tempo = 10000;
// Set length of pause between notes
int pause = 1000;
// Loop variable to increase Rest length
int rest_count = 100;

// Initialize core variables
int tone_ = 0;
int beat = 0;
long duration  = 0;

/** Daisy Bell 

CCC AAA FFF LowCCC

D E F DD F LowCCC CCC

*/

// MELODY and TIMING  =======================================
//  melody[] is an array of notes, accompanied by beats[],
//  which sets each notes relative length (higher #, longer note)
int melody[] = {  CT,  bT,  gT,  CT,  bT,   eT,  RT,  CT,  cT,  gT, aT, CT };
int beats[]  = { 16, 16, 16,  8,  8,  16, 32, 16, 16, 16, 8, 8 };
int MAX_COUNT = sizeof(melody) / 2; // Melody length, for looping.

// PLAY TONE  ==============================================
// Pulse the speaker to play a tone for a particular duration
void playTone() {
  long elapsed_time = 0;
  if (tone_ > 0) { // if this isnt a Rest beat, while the tone has
    //  played less long than duration, pulse speaker HIGH and LOW
    while (elapsed_time < duration) {

      digitalWrite(speakerOut,HIGH);
      delayMicroseconds(tone_ / 2);

      // DOWN
      digitalWrite(speakerOut, LOW);
      delayMicroseconds(tone_ / 2);

      // Keep track of how long we pulsed
      elapsed_time += (tone_);
    }
  }
  else { // Rest beat; loop times delay
    for (int j = 0; j < rest_count; j++) { // See NOTE on rest_count
      delayMicroseconds(duration);
    }
  }
}

void loop() {
  // Set up a counter to pull from melody[] and beats[]
  for (int i=0; i<MAX_COUNT; i++) {
    tone_ = melody[i];
    beat = beats[i];

    duration = beat * tempo; // Set up timing

    playTone();
    // A pause between notes...
    delayMicroseconds(pause);

   
  }
}
